//Project Webflow
//Leader Tom Haupt
//Prepared by Farhad Mamedbokov


import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import WebFlow.*;
import WebFlow.hashtable.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.lang.reflect.*;
import java.util.*;

public class Admin3 extends HttpServlet                           
{
  //variables that are extracted from the envoking URL
  private String sMasterRef;
  private String MyClassPath;
  private String MasterConfFile;
  private String DISPLAY;
  private String command;
  private String cmd_line;
  private String HashTableFile;

  //CORBA connection control variables for the server
  protected ORB orb;
  protected org.omg.CORBA.Object obj;
  protected WebFlowContext ws;

  //variables to add a new module and initilizre HashTable
  Method narrow = null;
  java.lang.Object[] MethodArg;
  Class Helper;    
  ContextData sc;        //HashTable interface

  private HttpServletResponse res;

  //Messages of succesful execution 
  //end of class variable declaraion
  

  protected void doGet(HttpServletRequest req, HttpServletResponse r)
          throws ServletException, IOException 
  {    
    res=r; 
    setParameters(req);
    
    String status = new String();
    
    if(command.equals("start"))
      status = startServer (cmd_line);
    else if(command.equals("SystemConf"))
    {
      status = addModule("ContextData");  
      status += StoreDataFromFile(HashTableFile);
    }

    else if(command.equals("ping"))
      status=pingServer(sMasterRef);
    else if(command.equals("kill"))
      status=killServer(sMasterRef); 
    else if(command.equals("conf"))
      status=getConf();
    else  
      status = getHelpLine();

    if(!command.equals("ping"))
      status+=pingServer(sMasterRef);

    System.out.println(status);    
    PrintPlainText(status);   
  }

  //-------Sets the parameters passed via html <PARAM
  protected void setParameters(HttpServletRequest req) {
    HashTableFile = req.getParameter("HashTableFile");

    command = req.getParameter("command");
    if (command==null) command=" ";
    
    MasterConfFile = req.getParameter("MasterConfFile");
    if(MasterConfFile==null) command=" "; 
    sMasterRef = req.getParameter("MasterIorFile");
    if(sMasterRef==null) command=" "; 
    MyClassPath = req.getParameter("ClassPath");
    if(MyClassPath==null) command=" "; 

    //defines the command line for the WebFlowServer invocation
    cmd_line = "java -cp "+MyClassPath+" WebFlow.Server "+MasterConfFile;
    //cmd_line = "java WebFlow.Server "+MasterConfFile;

    //display is passed for the debugging purposes.  
    DISPLAY = req.getParameter("display");
    if (DISPLAY!=null)
      if(DISPLAY.indexOf(":")>-1)
        cmd_line = "xterm -sb -d " +DISPLAY + "  -title master -e "+cmd_line;
  }

  //-------Prints the String status for the applet window------
  public void PrintPlainText(String status) throws IOException {
    res.setContentType("text/html");
    PrintWriter out = res.getWriter();
    out.println(status);
    out.close();
  }

  //------ creates orb, a class memeber variable ----------
  protected void createOrb() {
    String[] args = new String[1];
    args[0] = new String("");

    Properties props = System.getProperties();
    props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
    props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
    System.setProperties(props);
    orb = ORB.init(args, props);

    if(orb == null)
      System.out.println("ORB connecting error");
    else 
       System.out.println("ORB is created successfully"); 
  }

  //Converts class variables from IOR to ws object, checking for ORB  
  protected  WebFlowContext IOR2ws(String IOR) {
    if (orb== null) {
            createOrb();
    }

    if  (orb== null) {
        System.out.println("Could not create ORB");
        return null;
    }

    else {
      obj = orb.string_to_object(IOR);
       if(obj==null) System.out.println("obj is null");
      ws = WebFlowContextHelper.narrow(obj);
       if(ws == null) { 
          System.out.println("ws is null");
       } else {
          System.out.println("ws is OK");
       }
      return ws;
    }
  }
 
  
  //----------------reads object reference from a file------------
  public String ReadSTRFromFile(String FileName)   {
      //open the file
      FileInputStream theFile;
      BufferedReader fileReader;
      String IOR;

      try {
           theFile=new FileInputStream(FileName);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
           return "";
      }

      //read a reference string
      try {
        IOR=fileReader.readLine();
        System.err.println("Got the reference: "+IOR);
      }
      catch (IOException e) {
        return "Exception while reading the file: " + e;
      }
      
      try {
        theFile.close();
        fileReader.close();
      }
      catch (IOException e) { return "Exception while closing file " + e; }

      //return the reference string
      return IOR;
  }

///////////////////////////////////////////////////////////////////////
//      Functions to start, ping, terminate server
//      Added Help, ConfinInfo
//      in response to the corresponding applet button 
///////////////////////////////////////////////////////////////////////

//----if URL is osprey4.npac.syr.edu:2956/servlets/Admin2?command=start
//----starts the WebFlowServer------------------------------------
  public String startServer( String cmd_line)  {
   
    System.out.println("Starting WebFlowServer with " + cmd_line);
    try {
       Process prc_module_fac = Runtime.getRuntime().exec(cmd_line);        
       return  ("Executed: \n         " + cmd_line);
    } 
    catch (Exception ex) {
       System.err.println("Error in starting WebFlowServer :"+ex);
       return ("Cannot start " + cmd_line);
     }
   }

  //----if URL is osprey4.npac.syr.edu:2956/servlets/fm3?command=ping
  //-----pings the server to see if its alive 
  public String pingServer (String FileName)  {

    System.err.println("Pinging the server");   
    boolean non_exist = true;
    String MasterRef = ReadSTRFromFile(FileName);
   
    if (MasterRef.equals("")) 
         return  ("Cannot read reference from the file " + FileName + "\n");
    else    { 
      WebFlowContext ws=IOR2ws(MasterRef);
      System.out.println("ws should be defined now");   
      if (ws == null) 
         return "Cannot Connect to Object";
      else  {
	try {
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

	if (!non_exist)
          return ("\nObject is active\n");
	else
	    return  ("\nObject is NOT ACTIVE\n");
      }
    }  //else
  }  //pingServer


  //----if URL is osprey4.npac.syr.edu:2956/servlets/Admin2?command=kill
  //-----pings the server to see if its alive 
  public String killServer( String FileName)
  {   
    System.out.println("Killing the server");
    String MasterRef = ReadSTRFromFile(FileName);
    if (MasterRef.equals("")) 
       return "Cannot read reference from the file\n" +  sMasterRef;
    else
    { 
       ws =  IOR2ws(MasterRef);
       if (ws==null) 
          return "ws is null";
       else 
       {  
         try {
           ws.removeMyself();
           return "Envoked destruction method";
         }
         catch (org.omg.CORBA.COMM_FAILURE ex) { 
           return "Probably server is not active anyhow";
         }
         catch (Exception ex) {
           return ("Something wrong with terminating method: "+ex);
         }
       }  //else
     } //else
  }  //kill


  //----- if URL is osprey4.npac.syr.edu:2956/servlets/fm3
    //------or some erroneuos command-----------------------

  public String getConf() {
    String cs = "================================================\n";
    cs = cs + "current configuration of the master server \n\n";
    cs = cs + "ClassPath: "+MyClassPath+"\n";
    cs = cs + "Master Configuration File: "+MasterConfFile+"\n";
    cs = cs + "Master's IOR file "+sMasterRef+"\n\n";
    if(DISPLAY.indexOf(":")==-1) {
        cs=cs+"no display has been set\n\n";
    }
    else {
        cs=cs+"xxx display is set to "+DISPLAY+"\n\n";
    }
    cs = cs + "Note: this parameters are set in admin.html\n";
    cs = cs + "================================================\n";
    cs = cs + "start master WebFlow server using command:\n";

    cmd_line = "java WebFlow.Server "+MasterConfFile;

    //display is passed for the debugging purposes.  
    //DISPLAY = req.getParameter("display");
    if (DISPLAY!=null)
      if(DISPLAY.indexOf(":")>-1)
        cmd_line = "xterm -sb -d " +DISPLAY + "  -title master -e "+cmd_line;
    cs += cmd_line;
    cs = cs + "\n================================================\n";

    //add the HashTable Contents
    cs += getAllHashTable();
    return cs;
  }

  public String  getHelpLine()
  { 
    String HelpInfo=" \n";
    if(MasterConfFile==null) 
       HelpInfo=HelpInfo+"Oops: MasterConfFile is null\n";
    if(sMasterRef==null) 
       HelpInfo=HelpInfo+"Oops: sMasterRef is null\n";
    if(MyClassPath==null) 
       HelpInfo=HelpInfo+"Oops: ClassPath is null\n";
  
    HelpInfo = HelpInfo +"\n" +
        "Parameters:\n" +
        "    display (optional): starts the server in a new xwindow\n"+
        "    MasterConfFile: full path to the master configuration file\n"+   
        "    MasterIorFile : full path of the file where master's IOR is stored\n"+
        "                     Note: slave servers will acess it through URL\n"+
        "    ClassPath     :  class path needed to run a WebFlow server\n" +  
        "    servletURL    :  URL of the servlet that services this applet\n"+
        "    command       :  Available commands are:\n" +
	"                      start to start server\n" +
        "                      read  to read  server reference String\n" +
        "                      ping  to ping  server\n" +
        "                      kill  to kill  server\n" +
        "                      conf  to show values of the parameters passed to the server \n\n"+
        "    the command is selected by the applet, the other parameter are specified as the applet parameters in admin.html";

    return HelpInfo;

  }  //getHelpLine   



///////////////////////////////////////////////////////////////////////
//      Dynamically adds module by name
//      Copied from Tomasz Haupt code
//      This is more powerful than the servlets needs at the moment
///////////////////////////////////////////////////////////////////////

  public String addModule(String ModuleName) {
     org.omg.CORBA.Object Service=null;
     org.omg.CORBA.Object ServiceObj=null; 

           /* load ServiceHelper class */

      String HelperName = "WebFlow.hashtable."+ModuleName +"Helper";
      Helper = null;
      try {
           Helper = Class.forName(HelperName);
      } 
      catch (ClassNotFoundException cnfe) {
            System.out.println("Can't load "+HelperName);
            return ("Can't load "+HelperName);  
      }
      System.out.println("class "+HelperName+" loaded!");

      /* find narrow method */
      Method[] allMethods = Helper.getMethods();
      Class argList[]=null;
      int nmeth = allMethods.length; 
      int nmindx = 0; 
      for(int i=0;i<nmeth;i++) {
         if((allMethods[i].getName()).equals("narrow")) {
              nmindx = i;
              argList = allMethods[i].getParameterTypes();
	 } 
      }
      
      //narrow is a class variable
      narrow = null;
      try {
         narrow = Helper.getMethod("narrow",argList);
      } catch (NoSuchMethodException nsme) {
         System.out.println("No <<narrow>> method in "+HelperName);
         return ("No <<narrow>> method in "+HelperName);
      }  

      System.out.println("method narrow found ...");
      
      String MasterRef = ReadSTRFromFile(sMasterRef);
      if (MasterRef.equals("")) 
        return "Cannot read reference from the file\n" +  sMasterRef;
        
      ws=null;  
      ws =  IOR2ws(MasterRef);
      if (ws==null) 
          return "ws is null";

      System.out.println("Trying ws");
      try {
         ServiceObj = ws.addNewModule(ModuleName);
      }
      catch (Exception e) { 
         System.out.println("ws.addNewModule failed " + e);
         return ("ws.addNewModule failed " + e);
      }

       /* apply the narrow method to the service object */
       MethodArg = new java.lang.Object[1];
       MethodArg[0]=ServiceObj;
       try {
         System.out.println("trying invoke...");
         Service =(WebFlow.BeanContextChild)narrow.invoke(Helper,MethodArg);
         System.out.println("returned from invoke...");
       }
       catch (Exception e) {
         Throwable t;
         System.out.println("invoke exited with exception " + e);
         if(e instanceof InvocationTargetException)
            t = ((InvocationTargetException) e).getTargetException();
         else 
           t=e;
         System.out.println("invoke exited with exception " + t);
         //t.printStackTrace();
         return ("invoke  exited with exception " + t);
       }      
       System.out.println("returned narrow");
       return "Added Module" + ModuleName + " Succesfully\n"; 
  }


  //////////////////////////////////////////////////////////////
  //            HashTable Using functions  
  //////////////////////////////////////////////////////////////

  //returns true if the HashTable exists
  public int existHashTable()
  {   
    System.out.println("\nTesting the Hashtable Existance\n");
    try {
           sc.test();
           System.out.println("HashTable is in place ");
           return 1;
         }
         catch (Exception ex) {   
           System.out.println("Trying to establish hastable ");        
           try {
             sc = (ContextData) narrow.invoke(Helper, MethodArg);
             sc.test();
             System.out.println("HashTable is in place ");
             return 1;
           } 
           catch (Exception ex1) { 
             System.out.println("Cannot initialize the HashTabe ");
             return 0;
           }
        
        }
  } // existHashTable


  //Returnds all the data in HashTable
  public String getAllHashTable() {
   String cs="";
   if (existHashTable()!=0) {
       cs += "\n\nThe HashTable has parameters:\n";
       cs +=     "-----------------------------\n";
       String[] Keys = sc.getKeys();
       for (int i = 0; i<Keys.length; i++) {
         cs += (Keys[i] + "=" + sc.getParam(Keys[i]) + "\n");
       }
    }
    else {
      cs += "\nNo HashTable initialized\n";
    }  
    return cs;
  }
  
  //reads the given file and puts data into the hashtabel
   public String StoreDataFromFile(String FileName) {
      //open the file
      FileInputStream theFile;
      BufferedReader fileReader;
      String lineIn;
      
      if (existHashTable()==0)
         return "No HashTable Exists";

      try {
           theFile=new FileInputStream(FileName);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
         System.out.println("Did not find the file "+ FileName + " " +e);
         return "Did not find the file "+ FileName + " " +e;  
      }

      //read a reference string
      try {
        while ( (lineIn=fileReader.readLine()) !=null)
        {
          //lileIn =fileReader.readLine();
          String first = parseFirst(lineIn, "=");
          String second = parseSecond(lineIn, "=");
          System.out.println("Got the data: "+ first + "=" + second );
          sc.setParam(first,second);
        }
      }
      catch (IOException e) {
        System.out.println("reading the file " + FileName + " " +e);
        return "Exception while reading the file " + FileName + " " +e;
      }
      
      try {
        theFile.close(); 
        fileReader.close();
      }
      catch (IOException e) { 
        System.out.println("closing the file " + FileName + " " +e);
        return "closing the file " + FileName + " " +e;
      }

      //return the reference string
      return lineIn;
  }

  public String parseFirst(String s, String separator)
  {
     int sepPos=s.indexOf(separator);
     if (sepPos>0)
       return s.substring(0, sepPos);
     else 
       return  "";
  }

  public String parseSecond(String s, String separator)
  {
     int sepPos=s.indexOf(separator);
     if ((sepPos>0) && (sepPos+1<s.length()))
       return s.substring(sepPos+1);
     else return  "";
  }

  public String getServletInfo() 
  {
    return "Webflow Project, Leader Tomasz Haupt";
  }
}



















